module Logic(
	input clk,
	input btnLeft,
	input btnRight,
	input btnStart,
	output reg [2:0]ballX,
	output reg [2:0]ballY,
	output reg [2:0]padA,
	output reg [2:0]padB,
	output reg playing,
	output reg [3:0]scoreA,
	output reg [3:0]scoreB);
	
	reg ai = 1;

	integer speedX;
	integer speedY;
	
	always @(posedge clk)
	begin
		if (playing == 0)
		begin
			if(btnStart == 0)
			begin
				ballX = 4;
				ballY = 3;
				
				speedX = 1;
				speedY = 1;
				
				padA = 1;
				padB = 6;
				
				scoreA = 0;
				scoreB = 0;
				
				playing = 1;
			end
		end
		else
		begin
			// Ball
			if ((ballY + speedY) == 0 && (ballX) == (padA - 1))
			begin
				speedX = -1;
				speedY = speedY * (-1);
			end
			
			if ((ballY + speedY) == 0 && ballX == (padA))
			begin
				speedY = speedY * (-1);
			end
			
			if ((ballY + speedY) == 0 && ballX == (padA + 1))
			begin
				speedX = 1;
				speedY = speedY * (-1);
			end
			
			if ((ballY + speedY) == 7 && ballX == (padB - 1))
			begin
				speedX = -1;
				speedY = speedY * (-1);
			end
			
			if ((ballY + speedY) == 7 && ballX == (padB))
			begin
				speedY = speedY * (-1);
			end
			
			if ((ballY + speedY) == 7 && ballX == (padB + 1))
			begin
				speedX = 1;
				speedY = speedY * (-1);
			end
				
			if ((ballX + speedX) > 7 || (ballX + speedX) < 0)
			begin
				speedX = speedX * (-1);
			end
			
			if ((ballY + speedY) > 7 || (ballY + speedY) < 0)
			begin
				speedY = speedY * (-1);
			end

			ballX = ballX + speedX;
			ballY = ballY + speedY;
			
			// PadA
			if(ai == 1)
				begin
				if (ballX < padA && padA > 1)
				begin
					padA = padA - 1;
				end
				else if (ballX > padA && padA < 6) 
				begin
					padA = padA + 1;
				end
			end
			
			ai = !ai;
			
			// PadB
			if (btnLeft == 0 && padB > 1)
			begin
				padB = padB - 1;
			end
			else if (btnRight == 0 && padB < 6) 
			begin
				padB = padB + 1;
			end
			
			// Scoring
			if (ballY == 0)
			begin
				scoreB = scoreB + 1;
			end
			else if (ballY == 7)
			begin
				scoreA = scoreA + 1;
			end
			
			if(scoreA >= 7 || scoreB >= 7)
			begin
				playing = 0;
			end
		end
	end
endmodule