`define NO_LED 64
`define SIZE 8
`define ADDRESS 3

module Main(
	input btnLeft,
	input btnStart,
	input btnRight,
	output [(`SIZE - 1):0]row,
	output [(`SIZE - 1):0]col,
	output [7:0] LED);
	
	wire osc_clk;
	wire clkMain;
	wire [(`NO_LED - 1):0] mat;
	wire [2:0]ballX;
	wire [2:0]ballY;
	wire [2:0]padA;
	wire [2:0]padB;
	wire playing;
	wire [3:0]scoreA;
	wire [3:0]scoreB;
	
	assign LED[3:0] = ~scoreA;
	assign LED[7:4] = ~scoreB;

	OSCC OSCC_1 (.OSC(osc_clk));
	MainClock mainClock1(osc_clk, clkMain);
	Matrix matrix1(osc_clk, mat, row, col);
	Drawing drawing1(clkMain, ballX, ballY, padA, padB, playing, mat);
	Logic logic1(clkMain, btnLeft, btnRight, btnStart, ballX, ballY, padA, padB, playing, scoreA, scoreB);
endmodule